import sublime, sublime_plugin
import urllib, urllib2, threading
import desktop

class BbcodePreviewCommand(sublime_plugin.TextCommand):
    def run(self, edit):
        text = self.view.substr( sublime.Region(0, self.view.size()) )

        thread = BbcodeApiCall(text, 5)
        thread.start()
        self.handle_thread(edit, thread)

    def handle_thread(self, edit, thread):
        if thread.is_alive():
            sublime.set_timeout(lambda: self.handle_thread(edit, thread), 100)
        else:
            desktop.open("https://fumbbl.com/FUMBBL.php?page=bbcode&id=" + thread.result)
        return

class BbcodeApiCall(threading.Thread):
    def __init__(self, string, timeout):
        self.original = string
        self.timeout = timeout
        self.result = None
        threading.Thread.__init__(self)
    def run(self):
        try:
            data = urllib.urlencode({'bbcode': self.original})
            request = urllib2.Request('https://fumbbl.com/FUMBBL.php?page=bbcode', data,
                headers={"User-Agent": "Sublime BBCode Preview"})
            http_file = urllib2.urlopen(request, timeout=self.timeout)
            self.result = http_file.read()
            return
        except (urllib2.HTTPError) as (e):
            err = '%s: HTTP error %s contacting API' % (__name__, str(e.code))
        except (urllib2.URLError) as (e):
            err = '%s: URL error %s contacting API' % (__name__, str(e.reason))
        sublime.error_message(err)
        self.result = False